Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ERC/BooleanErcOptions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ERC/BooleanErcOptions.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ERC/BooleanErcOptions.cs	(revision 14777)
@@ -0,0 +1,26 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ERC {
+  using HeuristicLab.Common;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+  [StorableClass]
+  public class BooleanErcOptions : ErcOption<bool> {
+    public BooleanErcOptions() { }
+
+    [StorableConstructor]
+    public BooleanErcOptions(bool deserializing) : base(deserializing) { }
+
+    public BooleanErcOptions(BooleanErcOptions origin, Cloner cloner) : base(origin, cloner) {
+      AllowFalse = origin.AllowFalse;
+      AllowTrue = origin.AllowTrue;
+    }
+
+    [Storable]
+    public bool AllowFalse { get; set; }
+    [Storable]
+    public bool AllowTrue { get; set; }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new BooleanErcOptions(this, cloner);
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ERC/ErcOption.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ERC/ErcOption.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ERC/ErcOption.cs	(revision 14777)
@@ -0,0 +1,35 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ERC {
+  using System.Linq;
+
+  using HeuristicLab.Common;
+  using HeuristicLab.Core;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+  [StorableClass]
+  public class ErcOption<T> : NamedItem {
+
+    public ErcOption() {
+      Constants = new T[0];
+    }
+
+    public ErcOption(params T[] constants) {
+      Constants = constants;
+    }
+
+    [StorableConstructor]
+    public ErcOption(bool deserializing)
+      : base(deserializing) {
+      Constants = new T[0];
+    }
+
+    public ErcOption(ErcOption<T> origin, Cloner cloner) : base(origin, cloner) {
+      this.Constants = origin.Constants.ToArray();
+    }
+
+    public T[] Constants { get; set; }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ErcOption<T>(this, cloner);
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ERC/ErcOptionRange.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ERC/ErcOptionRange.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ERC/ErcOptionRange.cs	(revision 14777)
@@ -0,0 +1,28 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ERC {
+  using HeuristicLab.Common;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+  [StorableClass]
+  public class ErcOptionRange<T> : ErcOption<T>
+    where T : class, IDeepCloneable {
+    public ErcOptionRange(T start, T end, params T[] constants) : base(constants) {
+      Start = start;
+      End = end;
+    }
+
+    [StorableConstructor]
+    public ErcOptionRange(bool deserializing) : base(deserializing) { }
+
+    public ErcOptionRange(ErcOptionRange<T> origin, Cloner cloner) : base(origin, cloner) {
+      Start = cloner.Clone(origin.Start);
+      End = cloner.Clone(origin.End);
+    }
+
+    public T Start { get; set; }
+    public T End { get; set; }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ErcOptionRange<T>(this, cloner);
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ERC/ProblemErcOptions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ERC/ProblemErcOptions.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ERC/ProblemErcOptions.cs	(revision 14777)
@@ -0,0 +1,44 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ERC {
+  using HeuristicLab.Common;
+  using HeuristicLab.Core;
+  using HeuristicLab.Data;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+  [StorableClass]
+  public class ProblemErcOptions : NamedItem {
+    public ProblemErcOptions() { }
+
+    [StorableConstructor]
+    public ProblemErcOptions(bool deserializing) : base(deserializing) { }
+
+    public ProblemErcOptions(ProblemErcOptions origin, Cloner cloner) : base(origin, cloner) {
+      this.IntegerErcRange = cloner.Clone(origin.IntegerErcRange);
+      this.FloatErcRange = cloner.Clone(origin.FloatErcRange);
+      this.CharERCRange = cloner.Clone(origin.CharERCRange);
+      this.StringERCOptions = cloner.Clone(origin.StringERCOptions);
+      this.BooleanErcOptions = cloner.Clone(origin.BooleanErcOptions);
+    }
+
+    [Storable]
+    public double ErcProbability { get; set; }
+    [Storable]
+    public ErcOptionRange<IntValue> IntegerErcRange { get; set; }
+    [Storable]
+    public ErcOptionRange<DoubleValue> FloatErcRange { get; set; }
+    [Storable]
+    public BooleanErcOptions BooleanErcOptions { get; set; }
+
+    /// <summary>
+    /// Integer represents ASCII value
+    /// </summary>
+    [Storable]
+    public ErcOptionRange<IntValue> CharERCRange { get; set; }
+
+    [Storable]
+    public StringErcOptions StringERCOptions { get; set; }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ProblemErcOptions(this, cloner);
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ERC/StringErcOptions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ERC/StringErcOptions.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ERC/StringErcOptions.cs	(revision 14777)
@@ -0,0 +1,33 @@
+﻿namespace HeuristicLab.BenchmarkSuite.ERC {
+  using HeuristicLab.Common;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+  [StorableClass]
+  public class StringErcOptions : ErcOption<string> {
+
+    public StringErcOptions() { }
+
+    [StorableConstructor]
+    public StringErcOptions(bool deserializing) : base(deserializing) { }
+
+    public StringErcOptions(StringErcOptions origin, Cloner cloner) : base(origin, cloner) {
+      AllowLowercaseLetters = origin.AllowLowercaseLetters;
+      AllowUppercaseLetters = origin.AllowUppercaseLetters;
+      AllowSpace = origin.AllowSpace;
+      SpacePropability = origin.SpacePropability;
+    }
+
+    [Storable]
+    public bool AllowLowercaseLetters { get; set; }
+    [Storable]
+    public bool AllowUppercaseLetters { get; set; }
+    [Storable]
+    public bool AllowSpace { get; set; }
+    [Storable]
+    public double SpacePropability { get; set; }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new StringErcOptions(this, cloner);
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Example.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Example.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Example.cs	(revision 14777)
@@ -1,9 +1,69 @@
-﻿namespace HeuristicLab.BenchmarkSuite
-{
-  public class Example
-  {
-    public string Input { get; set; }
+﻿namespace HeuristicLab.BenchmarkSuite {
+  using System.Linq;
 
-    public string Output { get; set; }
+  using HeuristicLab.Common;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+  [StorableClass]
+  public class Example : DeepCloneable {
+    public Example() {
+      this.InputInt = new long[0];
+      this.InputFloat = new double[0];
+      this.InputBoolean = new bool[0];
+      this.OutputInt = this.InputInt;
+      this.OutputFloat = this.InputFloat;
+      this.OutputBoolean = this.InputBoolean;
+    }
+
+    public Example(Example origin, Cloner cloner) : base(origin, cloner) {
+      origin.CopyTo(this);
+    }
+
+    [StorableConstructor]
+    public Example(bool deserializing) { }
+
+    public void CopyTo(Example example) {
+      example.InputArgs = InputArgs.ToArray();
+      example.OutputArgs = OutputArgs.ToArray();
+
+      example.InputBoolean = InputBoolean.ToArray();
+      example.InputInt = InputInt.ToArray();
+      example.InputFloat = InputFloat.ToArray();
+
+      example.OutputBoolean = OutputBoolean.ToArray();
+      example.OutputInt = OutputInt.ToArray();
+      example.OutputFloat = OutputFloat.ToArray();
+    }
+
+    [Storable]
+    public string[] InputArgs { get; set; }
+    [Storable]
+    public string[] OutputArgs { get; set; }
+
+    [Storable]
+    public long[] InputInt { get; set; }
+    [Storable]
+    public double[] InputFloat { get; set; }
+    [Storable]
+    public bool[] InputBoolean { get; set; }
+    [Storable]
+    public char[] InputChar { get; set; }
+    [Storable]
+    public string[] InputString { get; set; }
+
+    [Storable]
+    public long[] OutputInt { get; set; }
+    [Storable]
+    public double[] OutputFloat { get; set; }
+    [Storable]
+    public bool[] OutputBoolean { get; set; }
+    [Storable]
+    public char[] OutputChar { get; set; }
+    [Storable]
+    public string[] OutputString { get; set; }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new Example(this, cloner);
+    }
   }
 }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ExampleArgumentConverter.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ExampleArgumentConverter.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ExampleArgumentConverter.cs	(revision 14777)
@@ -0,0 +1,60 @@
+﻿namespace HeuristicLab.BenchmarkSuite {
+  using System;
+  using System.Collections.Generic;
+  using System.IO;
+  using System.Linq;
+
+  public static class ExampleArgumentConverter {
+    private static readonly char[] ArrayValueSeparator = { ' ', ',', ';' };
+    private static readonly char[] ArraySymbolTrim = { '[', ']', '(', ')' };
+    public static double[] ConvertDoubles(string input) {
+      return ConvertMultiple(input, double.Parse);
+    }
+
+    public static double ConvertDouble(string input) {
+      return double.Parse(input);
+    }
+
+    public static long[] ConvertIntegers(string input) {
+      return ConvertMultiple(input, long.Parse);
+    }
+
+    public static long ConvertInteger(string input) {
+
+      return string.IsNullOrEmpty(input) ? default(long) : long.Parse(input);
+    }
+
+    public static T[] ConvertMultiple<T>(string input, Func<string, T> converter) {
+      return input
+       .Trim(ArraySymbolTrim)
+       .Split(ArrayValueSeparator)
+       .Where(s => !string.IsNullOrWhiteSpace(s))
+       .Select(converter)
+       .ToArray();
+    }
+
+    public static IEnumerable<string> SplitByNewLine(string input) {
+      return input.Split(new[] { Environment.NewLine, "\n", "\r\n" }, StringSplitOptions.None);
+    }
+
+    private static string[] trueFormats = new[] { "true", "t", "1" };
+    private static string[] falseFormats = new[] { "false", "f", "0" };
+
+    public static bool ConvertBoolean(string input) {
+      var str = input.ToLower();
+
+      if (trueFormats.Contains(str)) return true;
+      if (falseFormats.Contains(str)) return false;
+      throw new InvalidDataException(string.Format("Unable to parse {0} as boolean", str));
+    }
+
+    public static bool[] ConvertBooleans(string input) {
+      return input
+        .Trim(ArraySymbolTrim)
+        .Split(ArrayValueSeparator)
+        .Where(s => !string.IsNullOrWhiteSpace(s))
+        .Select(ConvertBoolean)
+        .ToArray();
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ExampleArgumentType.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ExampleArgumentType.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/ExampleArgumentType.cs	(revision 14777)
@@ -0,0 +1,12 @@
+﻿namespace HeuristicLab.BenchmarkSuite {
+  public enum ExampleArgumentType {
+    Integer,
+    IntegerCollection,
+    Float,
+    FloatCollection,
+    Bool,
+    String,
+    StringCollection,
+    Char,
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj	(revision 14777)
@@ -47,4 +47,8 @@
       <SpecificVersion>False</SpecificVersion>
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Core.Views-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Data-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Data-3.3.dll</HintPath>
     </Reference>
     <Reference Include="HeuristicLab.Data.Views-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
@@ -97,7 +101,16 @@
     <Compile Include="BenchmarkSuiteDataDescriptor.cs" />
     <Compile Include="BenchmarkSuiteInstanceProvider.cs" />
+    <Compile Include="DataTypes.cs" />
+    <Compile Include="ERC\BooleanErcOptions.cs" />
+    <Compile Include="ERC\ProblemErcOptions.cs" />
+    <Compile Include="ERC\ErcOption.cs" />
+    <Compile Include="ERC\ErcOptionRange.cs" />
+    <Compile Include="ERC\StringErcOptions.cs" />
+    <Compile Include="ExampleArgumentConverter.cs" />
     <Compile Include="IBenchmarkSuiteDataDescriptor.cs" />
     <Compile Include="Plugin.cs" />
-    <Compile Include="Problems\Example.cs" />
+    <Compile Include="Problems\Data.cs" />
+    <Compile Include="Example.cs" />
+    <Compile Include="ExampleArgumentType.cs" />
     <Compile Include="Problems\ReplaceSpaceWithNewline.cs" />
     <Compile Include="Problems\PigLatin.cs" />
@@ -116,4 +129,5 @@
     <Compile Include="Problems\CountOdds.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="Views\ViewHelper.cs" />
     <Compile Include="Views\DataEditorView.cs">
       <SubType>UserControl</SubType>
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/IBenchmarkSuiteDataDescriptor.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/IBenchmarkSuiteDataDescriptor.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/IBenchmarkSuiteDataDescriptor.cs	(revision 14777)
@@ -1,22 +1,8 @@
 ﻿namespace HeuristicLab.BenchmarkSuite {
   using HeuristicLab.BenchmarkSuite.Problems;
-  using HeuristicLab.Core;
   using HeuristicLab.Problems.Instances;
 
-  public interface IBenchmarkSuiteDataDescriptor : IDataDescriptor, INamedItem {
-    //Data CreateData();
-    Example[] Examples { get; }
-
-    string Name { get; }
-    string Description { get; }
-    int OriginalTrainingCount { get; }
-    int OriginalTestCount { get; }
-    int BestResult { get; }
-    int WorstResult { get; }
-    int InputArgumentCount { get; }
-    int OutputArgumentCount { get; }
-    int TotalArgumentCount { get; }
-
-    Example ParseExample(string[] input, string[] output);
+  public interface IBenchmarkSuiteDataDescriptor : IDataDescriptor {
+    Data CreateProblemData();
   }
 }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Checksum.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Checksum.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Checksum.cs	(revision 14777)
@@ -1,36 +1,31 @@
-﻿namespace HeuristicLab.BenchmarkSuite.Problems {
-  using System;
-  using System.Text;
+﻿//namespace HeuristicLab.BenchmarkSuite.Problems {
+//  using System;
+//  using System.Text;
 
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+//  public class Checksum : BenchmarkSuiteDataDescriptor {
+//    private const string name = "Checksum";
+//    private const string fileName = "Checksum.csv";
+//    private const string description = "";
+//    private readonly ExampleArgumentType[] inputArgumentTypes = { ExampleArgumentType.IntegerCollection };
+//    private readonly ExampleArgumentType[] outputArgumentTypes = { ExampleArgumentType.IntegerCollection };
 
-  [StorableClass]
-  public class Checksum : BenchmarkSuiteDataDescriptor {
-    private const string name = "Checksum";
-    private const string fileName = "Checksum.csv";
-    private const string description = "";
-    public Checksum() { }
+//    public override string Name { get { return name; } }
+//    protected override string FileName { get { return fileName; } }
+//    public override string Description { get { return description; } }
+//    public override ExampleArgumentType[] InputArgumentTypes { get { return inputArgumentTypes; } }
+//    public override ExampleArgumentType[] OutputArgumentTypes { get { return outputArgumentTypes; } }
+//    public override int OriginalTrainingCount { get { return 228; } }
+//    public override int OriginalTestCount { get { return 1254; } }
+//    public override int BestResult { get { return 0; } }
+//    public override int WorstResult { get { return byte.MaxValue; } }
 
-    [StorableConstructor]
-    public Checksum(bool deserializing) : base(deserializing) { }
-
-    public override string Name { get { return name; } }
-    protected override string FileName { get { return fileName; } }
-    public override string Description { get { return description; } }
-    public override int InputArgumentCount { get { return 1; } }
-    public override int OutputArgumentCount { get { return 1; } }
-    public override int OriginalTrainingCount { get { return 228; } }
-    public override int OriginalTestCount { get { return 1254; } }
-    public override int BestResult { get { return 0; } }
-    public override int WorstResult { get { return byte.MaxValue; } }
-
-    public override Example ParseExample(string[] input, string[] output) {
-      return new Example {
-        InputArgs = input,
-        OutputArgs = output,
-        InputInt = Array.ConvertAll(Encoding.ASCII.GetBytes(input[0]), c => (long)c),
-        OutputInt = Array.ConvertAll(Encoding.ASCII.GetBytes(output[0]), c => (long)c)
-      };
-    }
-  }
-}
+//    public override Example ParseExample(string[] input, string[] output) {
+//      return new Example {
+//        InputArgs = input,
+//        OutputArgs = output,
+//        InputInt = Array.ConvertAll(Encoding.ASCII.GetBytes(input[0]), c => (long)c),
+//        OutputInt = Array.ConvertAll(Encoding.ASCII.GetBytes(output[0]), c => (long)c)
+//      };
+//    }
+//  }
+//}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CountOdds.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CountOdds.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CountOdds.cs	(revision 14777)
@@ -1,25 +1,38 @@
 ﻿namespace HeuristicLab.BenchmarkSuite.Problems {
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+  using HeuristicLab.BenchmarkSuite.ERC;
+  using HeuristicLab.Data;
 
-  [StorableClass]
   public class CountOdds : BenchmarkSuiteDataDescriptor {
     private const string name = "Count Odds";
     private const string fileName = "CountOdds.csv";
     private const string description = "";
+    private readonly ExampleArgumentType[] inputArgumentTypes = { ExampleArgumentType.IntegerCollection };
+    private readonly ExampleArgumentType[] outputArgumentTypes = { ExampleArgumentType.Integer };
 
-    public CountOdds() { }
-
-    [StorableConstructor]
-    public CountOdds(bool deserializing) : base(deserializing) { }
+    private readonly DataTypes enabledDataTypeses = DataTypes.Exec | DataTypes.Integer | DataTypes.Boolean | DataTypes.IntegerVector;
+    private readonly ProblemErcOptions problemErcOptions = new ProblemErcOptions {
+      IntegerErcRange = new ErcOptionRange<IntValue>(
+        new IntValue(-1000),
+        new IntValue(1000),
+        new IntValue(0),
+        new IntValue(1),
+        new IntValue(2))
+    };
 
     public override string Name { get { return name; } }
     public override string Description { get { return description; } }
     protected override string FileName { get { return fileName; } }
-    public override int InputArgumentCount { get { return 1; } }
-    public override int OutputArgumentCount { get { return 1; } }
+    public override ExampleArgumentType[] InputArgumentTypes { get { return inputArgumentTypes; } }
+    public override ExampleArgumentType[] OutputArgumentTypes { get { return outputArgumentTypes; } }
     public override int OriginalTrainingCount { get { return 200; } }
     public override int OriginalTestCount { get { return 2000; } }
     public override int BestResult { get { return 0; } }
     public override int WorstResult { get { return 50; } }
+    public override ProblemErcOptions ProblemErcOptions { get { return this.problemErcOptions; } }
+    public override DataTypes EnabledDataTypes { get { return this.enabledDataTypeses; } }
+    public override int MaxSize { get { return 500; } }
+    public override int EvalLimit { get { return 1500; } }
+    public override int MaxGenerations { get { return 300; } }
+    public override int ProgEvalBudget { get { return 60000000; } }
 
     public override Example ParseExample(string[] input, string[] output) {
@@ -27,6 +40,6 @@
         InputArgs = input,
         OutputArgs = output,
-        InputInt = ConvertIntegers(input[0]),
-        OutputInt = ConvertIntegers(output[0])
+        InputInt = ExampleArgumentConverter.ConvertIntegers(input[0]),
+        OutputInt = ExampleArgumentConverter.ConvertIntegers(output[0])
       };
     }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Data.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Data.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Data.cs	(revision 14777)
@@ -0,0 +1,85 @@
+﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using System.Linq;
+
+  using HeuristicLab.BenchmarkSuite.ERC;
+  using HeuristicLab.Common;
+  using HeuristicLab.Core;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+  [StorableClass]
+  public class Data : NamedItem {
+
+    public Data() { }
+
+    [StorableConstructor]
+    protected Data(bool deserializing) : base(deserializing) { }
+
+    public Data(Data origin, Cloner cloner) : base(origin, cloner) {
+      Name = origin.Name;
+      Description = origin.Description;
+      OriginalTrainingCount = origin.OriginalTrainingCount;
+      OriginalTestCount = origin.OriginalTestCount;
+      BestResult = origin.BestResult;
+      WorstResult = origin.WorstResult;
+      InputArgumentTypes = origin.InputArgumentTypes;
+      OutputArgumentTypes = origin.OutputArgumentTypes;
+      Examples = origin.Examples.ToArray();
+      EnabledDataTypes = origin.EnabledDataTypes;
+      this.ProblemErcOptions = cloner.Clone(origin.ProblemErcOptions);
+    }
+
+    [Storable]
+    public string Name { get; set; }
+    [Storable]
+    public string Description { get; set; }
+    [Storable]
+    public int OriginalTrainingCount { get; set; }
+    [Storable]
+    public int OriginalTestCount { get; set; }
+    [Storable]
+    public int BestResult { get; set; }
+    [Storable]
+    public int WorstResult { get; set; }
+    [Storable]
+    public ExampleArgumentType[] InputArgumentTypes { get; set; }
+    [Storable]
+    public ExampleArgumentType[] OutputArgumentTypes { get; set; }
+    public int TotalArgumentCount { get { return InputArgumentTypes.Length + OutputArgumentTypes.Length; } }
+    [Storable]
+    public Example[] Examples { get; set; }
+    [Storable]
+    public ProblemErcOptions ProblemErcOptions { get; set; }
+    [Storable]
+    public DataTypes EnabledDataTypes { get; set; }
+
+    /// <summary>
+    /// Max Size” gives the maximum number of instructions that can appear in an individual’s genome
+    /// </summary>
+    [Storable]
+    public int MaxSize { get; set; }
+
+    /// <summary>
+    /// “Eval Limit” is the number of steps of the Push interpreter that are executed before stopping a
+    /// program’s execution; programs halted in this way may still achieve good results if they print or
+    /// return results before they are stopped
+    /// </summary>
+    [Storable]
+    public int EvalLimit { get; set; }
+
+    /// <summary>
+    /// “Max Gens” gives the maximum number of generations in a single PushGP run.
+    /// </summary>
+    [Storable]
+    public int MaxGenerations { get; set; }
+
+    /// <summary>
+    /// “Prog Eval Budget” is the maximum number of programs that will be evaluated before a run is terminated.
+    /// </summary>
+    [Storable]
+    public int ProgEvalBudget { get; set; }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new Data(this, cloner);
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Views/DataEditorView.Designer.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Views/DataEditorView.Designer.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Views/DataEditorView.Designer.cs	(revision 14777)
@@ -33,9 +33,9 @@
       this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
       this.errorProvider.SetIconPadding(this.nameTextBox, 2);
-      this.nameTextBox.Size = new System.Drawing.Size(302, 20);
+      this.nameTextBox.Size = new System.Drawing.Size(758, 20);
       //
       // infoLabel
       //
-      this.infoLabel.Location = new System.Drawing.Point(366, 3);
+      this.infoLabel.Location = new System.Drawing.Point(822, 3);
       //
       // dataGridView
